/*
Copyright 2019 caicloud authors. All rights reserved.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/caicloud/cyclone/pkg/apis/cyclone/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeProjects implements ProjectInterface
type FakeProjects struct {
	Fake *FakeCycloneV1alpha1
	ns   string
}

var projectsResource = schema.GroupVersionResource{Group: "cyclone.dev", Version: "v1alpha1", Resource: "projects"}

var projectsKind = schema.GroupVersionKind{Group: "cyclone.dev", Version: "v1alpha1", Kind: "Project"}

// Get takes name of the project, and returns the corresponding project object, and an error if there is any.
func (c *FakeProjects) Get(name string, options v1.GetOptions) (result *v1alpha1.Project, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(projectsResource, c.ns, name), &v1alpha1.Project{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Project), err
}

// List takes label and field selectors, and returns the list of Projects that match those selectors.
func (c *FakeProjects) List(opts v1.ListOptions) (result *v1alpha1.ProjectList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(projectsResource, projectsKind, c.ns, opts), &v1alpha1.ProjectList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ProjectList{}
	for _, item := range obj.(*v1alpha1.ProjectList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested projects.
func (c *FakeProjects) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(projectsResource, c.ns, opts))

}

// Create takes the representation of a project and creates it.  Returns the server's representation of the project, and an error, if there is any.
func (c *FakeProjects) Create(project *v1alpha1.Project) (result *v1alpha1.Project, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(projectsResource, c.ns, project), &v1alpha1.Project{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Project), err
}

// Update takes the representation of a project and updates it. Returns the server's representation of the project, and an error, if there is any.
func (c *FakeProjects) Update(project *v1alpha1.Project) (result *v1alpha1.Project, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(projectsResource, c.ns, project), &v1alpha1.Project{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Project), err
}

// Delete takes name of the project and deletes it. Returns an error if one occurs.
func (c *FakeProjects) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(projectsResource, c.ns, name), &v1alpha1.Project{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeProjects) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(projectsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.ProjectList{})
	return err
}

// Patch applies the patch and returns the patched project.
func (c *FakeProjects) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.Project, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(projectsResource, c.ns, name, data, subresources...), &v1alpha1.Project{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Project), err
}
